function [F] = Tpedersen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%This matlab script is developed for the Analysis with Initial Pipeline  %%
%imperfection, based on the Terndrup-Pedersen model. It is developed by  %%
%Shengsheng Fan, who is going to work in JP kenny afterwards, some of the%%
%theory used here is based on Terndrup-Pedersen's paper and design guide %%
%of UHB from JP kenny%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
%define soil cover depth, varying from 0.4 to 1.6 [m]
H=[0.4,0.6,0.8,1.0,1.2,1.4,1.6];
for st=1:max(size(H))
    %------------------ given parameter------------------------------------
    g=9.81;   %Gravitational Acceleration [N/Kg]
    Miu=0.3;      %poisson ratio
    E=2.07*10^11; %Young's Modulus of Elasticity E [N/m^2]
    ro_s=7850;    %Density of Pipeline steel [kg/m^3]
    ro_w=1025;    %Density of Seawater [kg/m^3]
    % ro_sc=input('Density of soil cover=');%Density of soil cover [kg/m^3]
    ro_sc=1000;;  %Density of soil cover [kg/m^3
    % De=input('pipe external diameter[m] = '); %pipe external diameter [m]
    % t=input('pipe wall thickness[m] = '); %pipe wall thickness [m]
    % h_w=input('water depth[m] = '); %water depth[m]
    % delta_p=input('pressure difference pi-pe [N/m^2 or pa] = ')%pressure difference pi-pe [N/m^2 or pa]
    % ro_c=input('Density of Pipe Contents='); %Density of Pipe Contents  [kg/m^3]
    ro_c=820;
    % D0=input('overall outside diameter of pipeline= [m]')
    D0=0.4;%overall outside diameter of pipeline[m], coating included
    De=0.214+0.0142; %pipe external diameter [m]
    t=14.2/1000; %pipe wall thickness [m]
    Di=De-2*t; %pipe internal diameter [m]
    As=pi/4*(De^2-Di^2); %steel area  [m^2]
    I=pi/64*(De^4-Di^4);%second moment [m^4]
    delta_pre=23*10^6; %maximum pressure difference [N/m^2 or pa] 
    w_p=As*ro_s; %dry weight of pipe [kg/m]
    w_cont=pi/4*Di^2*ro_c; %dry weight of contents [kg/m]
    w_coat=74.2714; %dry weight of coatings [kg/m]
    F_B=pi/4*De^2*ro_w; %Buoyance Force [kg/m]
    w0=w_p+w_cont+w_coat-F_B;%submerged operating weight [kg/m]
    %submerged installation weight, apart from the weight of contents
    q_pipe=w0*g; %pipe operating submerged weight [N/m]
    %------ Establish initial imperfection configuration ------------------
    % dalta_f=input('foundation imperfection amplitude[m] = ')
    % dalta_p=input('pipeline imperfection amplitude=[m] = ')
    delta_f=0.3; %foundation imperfection amplitude [m]
    delta_p=delta_f; %foundation imperfection amplitude [m]
    L0= (72*delta_p*E*I/q_pipe)^0.25; %half wavelength of foundation imperfection [m]
    q_pipe1=72*E*I*delta_p/L0^4; %pipe installation submerged weight [N/m]
    x=0:L0/50:L0;
    for i=1:max(size(x))
        delt_f(i)=delta_f*(x(i)/L0)^3*(4-3*x(i)/L0);
    end
    for i=1:max(size(x))
        delt_p(i)=delta_p*(x(i)/L0)^3*(4-3*x(i)/L0);
    end
    % figure (1)
    % subplot (2,1,1)
    % plot(x,delt_f)
    % grid on
    % xlabel('x/m')
    % ylabel('y/m')
    % title('foundation imperfection')
    % text(L0,delta_f,'A0=0.3m')
    % axis([0 L0 0 1.2])
    % subplot (2,1,2)
    % plot(x,delt_p)
    % grid on
    % xlabel('x/m')
    % ylabel('y/m')
    % title('pipeline imperfection')
    % text(L0,delta_p,'A0=0.3m')
    % axis([0 L0 0 1.2])
    %----------------------------------------------------------------------
    %------ Define the trench profile  ------------------------------------
    % H=input('burial depth of the pipe centre line[m] = ')
    % H_T=input('trench depth[m] =')
    % H_R=input('burial height above seabed[m] =')
    % Fai_T=input('trench angle=[deg]')
    % Fi_c=input('internal friction angle of the burial material=[deg]')
    % H_T=1.4;
    % H_R=1.2;
    % Fai_T=0;
    Fi_c=20;
    % kesita=D0/(2*cos(Fai_T));
    %----------------------------------------------------------------------
    %------ Calculate the cover weight due to burial-----------------------
    % % % disp('  1) Trenched');
    % % % disp('  2) Untrenched');
    % % % LC = input('  Choose 1(default) or 2 :');
    % % % if isempty(LC) | LC<1 | LC>2 
    % % %    LC = 1;
    % % % end
    % % % LC=1;
    % LC=1;
    % %Trenched profile
    % if LC==1
    %     if H<=D0/2
    %         q_s=0;
    %     else if H>D0/2&H<=H_T-kesita
    %             q_s=ro_sc*g*(H*D0-pi/8*D0^2+H^2*tan(Fi_c*pi/180));
    %         else H>H_T-kesita
    %             q_s=ro_sc*g*(H*D0-pi/8*D0^2+H^2*tan(Fi_c*pi/180)*cos(Fi_c*pi/180)^2);
    %         end
    %     end
    % end
    % %Untrenched profile
    % if LC==2
    %     if H<=D0/2
    %         q_s=0;
    %     else H>D0/2
    %         q_s=ro_sc*g*(H*D0-pi/8*D0^2+H^2*tan(Fi_c*pi/180)*cos(Fi_c*pi/180)^2);
    %     end
    % end
    q_s=ro_sc*g*(H(st)*D0-pi/8*D0^2+H(st)^2*tan(Fi_c*pi/180));
    QQ(st)=q_s;
    % %--------------------------------------------------------------------
    % q_s=input('uplift resistance of the cover material N/m ='); 
    %uplift resistance of the cover material N/m
    q=q_pipe+q_s;  %total download in the buckle region [N/m]
    
    %-------Calculate the friction or give the friction coefficient------------ 
    % % q_c=ro_sc*g*(H*D0-pi/8*D0^2);
    % % q_b=ro_sc*g*(H*D0-pi/8*D0^2)+q_pipe;
    % % miu_ac=tan(Fi_c*pi/180); %friction coefficient of burial/pipe interface
    % % miu_ab=0.5; %friction coefficient of pipe/foundation interface
    % % q_equal=miu_ac*q_c+miu_ab*q_b;
    % % namuta1=q_equal/q_s;
    nanmuta=0.5; %Friction coefficient betwwen pipe and soil
    %----------------------------------------------------------------------
    %-------Calculate the effective aixal compressive load N---------------
    %N has contributions from the compressive load plus internal pressure
    %component, read reference 7 from Perdesen's paper
    %N=k^2*E*I;
    afa=(q+q_pipe)/(E*I);
    %define a maximum uplift value,here from JP kenny we choose 0.02m, i.e. 2cm
    delta_limit=0.02;
    %find the critical buckle legth by iteration
    % Define the buckle length by a ratio beteew L and L0, denote ratio=L/L0;
    ratio=0.0001:0.0001:1;
    for i=1:max(size(ratio))
        ratio1=ratio(i);
        L=ratio1*L0;
        %     q_f=72*E*I*delta_p/L0^4; %simplified model, pipeline imperfection and foundation imperfection are the same
        %------------calculate needed parameter--------------------------------
        %beta
        q_f=q_pipe;
        beta=24*delta_p*(3*L-2*L0)/L0^4+q*L/(E*I);
        %gama and kappa
        if L<=L0
            gama=q_f/(6*E*I)*(L0-L)*(3*L-L0);
            kappa=q_f/(6*E*I)*(L0-L)^2*L;
        else
            gama=0;
            kappa=0;
        end
        %------------solve the equation for the lowest eigenvalue--------------
        Equation1=@(k)(afa/k^3+gama/k)*sin(k*L)-(beta/k^2-kappa)*cos(k*L)+1/k^2*(-afa*L+beta);
        %there can be several roots for this function using fzero, here I
        % define three different start value to make sure fzero can find the
        %smallest abs(k) for buckle force
        k1=fzero(Equation1,10^-5);
        k2=fzero(Equation1,10^-1);
        k3=fzero(Equation1,10^0);
        kk=[k1,k2,k3];
        kk1=abs(kk);
        k_position1=find(abs(kk)==min(kk1));
        k_position=max(k_position1);
        k0=kk(k_position);
        K(i)=k0;
        %here I want to define the maximum uplift, in the buckle region
        A=-(afa/k0^4+gama/k0^2);
        B=-beta/k0^3+kappa/k0;
        %     xx=0:L/10000:L;
        %     temp1=L0-L;
        %     ww0=delta_p.*((xx+temp1)./L0).^3.*(4-3*(xx+temp1)./L0);
        %     ww1=A.*cos(k.*xx)+B.*sin(k.*xx)+1/k^2.*(-0.5*afa.*xx.^2+beta.*xx+afa/k^2+gama);
        %     dw(i)=max(ww0-ww1);
   
        temp1=delta_p*((L0-L)/L0)^3*(4-3*(L0-L)/L0);
        dw(i)=A*cos(k0*L)+B*sin(k0*L)+1/k0^2*(-0.5*afa*L^2+beta*L+afa/k0^2+gama)-delta_p+temp1;
    end
    clear i
    % figure (5)
    % plot(xx,ww0,'-',xx,ww1,'*')
    ratio0_position=find(dw<=delta_limit);
    ratio0=ratio(max(ratio0_position));
    aaaa=dw(max(ratio0_position));
    L=ratio0*L0;
    k=K(max(ratio0_position));
    %----------------------------------------------------------------------
    
    %-------Calculate the needed parameter for critical configuration------
    %beta
    beta=24*delta_p*(3*L-2*L0)/L0^4+q*L/(E*I);
    %gama and kappa
    if L<=L0
        gama=q_f/(6*E*I)*(L0-L)*(3*L-L0);
        kappa=q_f/(6*E*I)*(L0-L)^2*L;
    else
        gama=0;
        kappa=0;
    end
    A=-(afa/k^4+gama/k^2);
    B=-beta/k^3+kappa/k;
    %calculate the effective aixal compressive load N
    N=k^2*E*I;   %effective aixal compressive load N
    NN(st)=N;
    %--------------------------------------------------------------------------
    %-------Calculate the maximum aixal force N0-------------------------------
    % First term in U_sb
    integ1=0.5*k*A^2*(k*L-cos(k*L)*sin(k*L))+0.5*k*B^2*(k*L+cos(k*L)*sin(k*L))...
    +1/3*afa^2*(k*L)^3/k^7+beta^2*k*L/k^5-k*A*B*(sin(k*L))^2+2*A*afa/k^3*(sin(k*L)-k*L*cos(k*L))...
    -2*A*beta/k^2*(1-cos(k*L))-2*B*afa/k^3*(cos(k*L)+k*L*sin(k*L)-1)+2*B*beta/k^2*sin(k*L)...
    -afa*beta*L^2/k^4;
    % Second term in U_sb
    integ2=(q_f/(6*E*I))^2*(1/5*L0^2*(L0^5-(L0-L)^5)+1/7*(L0^7-(L0-L)^7)-1/3*L0*(L0^6-(L0-L)^6));
    N0=N+(q*nanmuta*E*As*(integ1-integ2)-(q*nanmuta*L)^2)^0.5;%from Pedersen paper
    NN0(st)=N0;
    %--------------------------------------------------------------------------

    %-------Calculate allowable temperature difference delta T-------------------------------
    % N_lay=input('residual lay tension=[N] ')% residual lay tension [N]
    N_lay=0;
    D=(De+Di)/2;
    Fp=pi/4*(1-2*Miu)*D^2*delta_pre;%from JPkenny Pressure induced compressive load [N]
    % % delta_pre1=-delta_pre;
    Fp1=Miu*pi/2*D^2*delta_pre;%By Terndrup-Pedersen model 
    Ft=N0-Fp+N_lay; %allowable thermally induced compressive load [N]
    afa_s=11.7*10^-6; %coefficient of thermal expansion
    delta_T=Ft/(As*E*afa_s);
    TT(st)=delta_T;
    % % if L<L0
% % % % %     plot the lowest eigenmode of the buckle region
% %     x1=0:L/50:L;
% %     for i=1:max(size(x1))
% %         w(i)=A*cos(k*x1(i))+B*sin(k*x1(i))+1/k^2*(-0.5*afa*x1(i)^2+beta*x1(i)+afa/k^2+gama);
% %     end
% %     clear i
% %     figure (3)
% %     plot(x1,w)
% % % % % %       Plot the shape before lift up point
% %     x2=0:(L0-L)/50:L0-L;
% %     clear i
% %     for i=1:max(size(x2))
% %         w1(i)=delta_p*(x2(i)/L0)^3*(4-3*x2(i)/L0);
% %     end
% %     x3=L0-L:(L0-L)/50:L0;
% %     clear i
% %     for i=1:max(size(x3))
% %         w2(i)=delta_p*((L0-L)/L0)^3*(4-3*(L0-L)/L0)+A*cos(k*(x3(i)-(L0-L)))...
% %         +B*sin(k*(x3(i)-(L0-L)))+1/k^2*(-0.5*afa*(x3(i)-(L0-L))^2+beta*...
% %         (x3(i)-(L0-L))+afa/k^2+gama);
% %     end
% %     xx=[x2,x3];
% %     ww=[w1,w2];
% %     figure (2)
% %     plot(xx,ww)
% %     xlabel('x/m')
% %     ylabel('y/m')
% %     title('buckle configuration')
% %     text(L0,delta_f,'A0=0.3m')
% %     axis([0 L0,0,max(ww)])
% % else 
% %     x4=0:L/50:L;
% %     clear i
% %     for i=1:max(size(x4))
% %         w3(i)=A*cos(k*x4(i))+B*sin(k*x4(i))+1/k^2*(-0.5*afa*x4(i)^2+beta*x4(i)+afa/k^2+gama);
% %     end
% %     figure (2)
% %     xx=[x4];
% %     ww=[w3];
% %     plot(xx,ww)
% %     xlabel('x/m')
% %     ylabel('y/m')
% %     title('buckle configuration')
% %     text(L0,delta_f,'A0=0.3m')
% %     axis([0 L0,0,max(ww)])
% % end
      TT(st)=delta_T;
      %calculate the maximum bending moment 
      M_max=E*I*(A*k^2*cos(k*L)+B*k^2*sin(k*L)+afa/k^2);
      MM_max(st)=M_max;
% % V_max=max(ww)-delta_p;
      V_max1=0.002470*q_s*L^4/(E*I);%proposed maximum uplift from JP
      M_max1=-0.06938*q_s*(L^2-L0^2);%proposed maximum bending moment from JP
      %bending stress
      Sigma_B=M_max*De/(2*I);
      %axial stress
      sigma_A=N/As;
% Lame stress distribution
% % % %hoop stress
% % % Sigma_h= function of Pi Po and De Di
% % % %calculate the maximum equivalent stress
% % % Sigma_E=sigma_A+Sigma_B+Miu*Sigma_h;
%calculate the maximum amplitude of the buckle region
% v_max=0.002407*q_s*L^4/(E*I); %proposed value from JPK, 
% % % notice q_s not q here
end
output=[TT;QQ;NN;NN0;MM_max]';
TTTT=QQ(4)*L0^2/(12*afa_s*E*As*delta_f)-delta_pre*D0*0.4/(4*E*t*afa_s)
end
